/*! \class CPointLight
 *  \brief Cette classe dfnie une omni light, c'est  dire une lampe
 *  reprsente par un point qui met de la lumire uniformment dans toutes les directions.
 *  \author Benot Lemaire (aka DaRkWoLf)
 *  \date   19/04/2002
 */

#ifndef __CPOINTLIGHT_H__
#define __CPOINTLIGHT_H__

#include "CLight.h"

class CPointLight : public CLight
{	
	public:
		// constructeurs et destructeur
		CPointLight() {};
		CPointLight(const CVector3D& position, float diffuseColor, float specularColor, const CColor& color) 
		: CLight(position, diffuseColor, specularColor, color, OMNILIGHT) { }
		virtual ~CPointLight() {};

		// [hrit de CLight]
		CColor GetLightAt(CVector3D& normal, CVector3D& intersectionPoint, CMaterial* material);
};

#endif /* #ifndef __CPOINTLIGHT_H__ */